Subject: Re: context switch within RCU read-side critical section in next-20260518+ with PREEMPT_RT

From: Bert Karwatzki <[email-masked]>
Date: Thu, 21 May 2026 12:13:54 +0200

Am Donnerstag, dem 21.05.2026 um 12:05 +0200 schrieb Thomas Gleixner:
> On Thu, May 21 2026 at 10:53, Mateusz Guzik wrote:
> > On Thu, May 21, 2026 at 12:52:44AM +0200, Bert Karwatzki wrote:
> > > With these reverts next-20260519 boots 30 times in a row without error, so
> > > it appears that commit dc651e25a6d2 ("fs: RCU-ify filesystems list") causing the
> > > error.
> > > 
> > 
> > I think the patch below will do the trick.
> > 
> > If someone wonders how come the missing unlocks: the original patch had
> > them in place, but when I was rebasing on top of the RCU-ifing commit I
> > figured I'm going to do guard/scoped_guard in there as well. Later it
> > started failing as the compiler did not like goto retry out of a scoped
> > guard area and the unlocks did not come back.
> > 
> > tl;dr there is definitely my bug here and it is most likely *the* bug
> 
> I was staring at the wrong commit then :)

Sorry, as the bug was rather hard to trigger (with PREEMPT_RT at least) I
wanted to save myself from 100-150 reboot cycles during the bisection.

Bert Karwatzki